/*
 *      file.c from Access Point SNMP Utils for Linux
 * file accessing functions
 *
 * Copyright (c) 2002 Roman Festchook <roma at polesye dot net>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2 from
 * June 1991 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */
#include <sys/wait.h>
#include <ncurses.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <signal.h>
#include <string.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
#include "ap-utils.h"

void save_Stations(struct MacListStat *curr)
{
    int fd;
    extern char ap_type;
    char *home_dir;
    char message[1024];
    if ((home_dir = getenv("HOME"))) {
	sprintf(message, "%s/ap-%s.stations", home_dir,
		(ap_type ? "nwn" : "atmel"));
	if ((fd = creat(message, 0600)) != -1) {
	    while (curr) {
		sprintf(message, "%02X%02X%02X%02X%02X%02X\n",
			curr->addr[0] & 0xFF, curr->addr[1] & 0xFF,
			curr->addr[2] & 0xFF, curr->addr[3] & 0xFF,
			curr->addr[4] & 0xFF, curr->addr[5] & 0xFF);
		write(fd, message, 13);
		curr = curr->next;
	    }
	    close(fd);
	}
    }
}

int get_opts()
{
    extern char ap_type, *community;
    extern struct in_addr ap_ip;
    extern int sockfd;
    char Wireless[2][12] = {
        {0x2B, 0x06, 0x01, 0x04, 0x01, 0x83, 0x1a, 0x01, 0x01, 0x01, 0x05, 
         0x00},
        {0x2B, 0x06, 0x01, 0x02, 0x01, 0x01, 0x02, 0x00}
    };
    varbind varbinds[1];


    char *home_dir, i = 0, flag = 0, buf[1024], mess[64];
    struct sockaddr_in client;
    int fd;
    signed char j;

    memset(&client, 0, sizeof client);
    client.sin_family = AF_INET;
    client.sin_port = INADDR_ANY;
    client.sin_addr.s_addr = INADDR_ANY;


    if ((home_dir = getenv("HOME")) == NULL)
	return 0;
    sprintf(buf, "%s/.ap-config", home_dir);
    if ((fd = open(buf, O_RDONLY)) == -1)
	return 0;
    j = read(fd, buf, sizeof(buf));
    if (j == -1 || j == 0)
	return 0;
    i = 0;
    while (i < j) {
	if (*(buf + i) != 0x0a)
	    *(mess + i - flag) = *(buf + i);
	else {
	    *(mess + i - flag) = '\0';
	    if (flag == 0) {
		if (inet_aton(mess, &ap_ip) == 0)
		    return 0;
		flag = i + 1;
	    } else {
		if (community)
		    free(community);
		i = strlen(mess) + 1;
		community = (char *) malloc(i);
		strncpy(community, mess, i);
		ap_type = *(buf + j-1);
		break;
		
	    }
	}
	i++;
    }
    close(fd);

    if (sockfd)
	close(sockfd);
    if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
	return 0;

    if (bind(sockfd, (struct sockaddr *) &client, SIZE) == -1)
	return 0;

	print_bottom(inet_ntoa(ap_ip));

        return 1;
}

